#!/usr/bin/perl
use strict;
use warnings;

sub decode {
	my $history = shift;
	my $bank = 1;
	my $misioL = 3;
	my $canibaL = 3;
	my $misioR = 3 - $misioL;
	my $canibaR = 3 - $canibaL;
	while ($history) {
		$history =~ s/^(\d)//;
		my $op = $1;
		if ($bank) {
			# levy breh
			if ($op == 1) {
				$misioL--;
				print "\tM$misioL K$canibaL:\t---    |M   >    ---\t:M$misioR K$canibaR\n";
				$misioR++;
			} elsif ($op == 2) {
				$misioL -= 2;
				print "\tM$misioL K$canibaL:\t---    |MM  >    ---\t:M$misioR K$canibaR\n";
				$misioR += 2;
			} elsif ($op == 3) {
				$canibaL--;
				print "\tM$misioL K$canibaL:\t---    |K   >    ---\t:M$misioR K$canibaR\n";
				$canibaR++;
			} elsif ($op == 4) {
				$canibaL -=  2;
				print "\tM$misioL K$canibaL:\t---    |KK  >    ---\t:M$misioR K$canibaR\n";
				$canibaR +=  2;
			} else {
				$misioL--; $canibaL--;
				print "\tM$misioL K$canibaL:\t---    |MK  >    ---\t:M$misioR K$canibaR\n";
				$misioR++; $canibaR++;				 
			}				
		} else {
			#pravy breh
			if ($op == 1) {
				$misioR--;
				print "\tM$misioL K$canibaL:\t---    <   M|    ---\t:M$misioR K$canibaR\n";
				$misioL++; 
			} elsif ($op == 2) {
				$misioR -= 2;
				print "\tM$misioL K$canibaL:\t---    <  MM|    ---\t:M$misioR K$canibaR\n";
				$misioL += 2; 
			} elsif ($op == 3) {
				$canibaR--;
				print "\tM$misioL K$canibaL:\t---    <   K|    ---\t:M$misioR K$canibaR\n";
				$canibaL++; 
			} elsif ($op == 4) {
				$canibaR -= 2;
				print "\tM$misioL K$canibaL:\t---    <  KK|    ---\t:M$misioR K$canibaR\n";
				$canibaL += 2; 
			} else {
				$misioR--; $canibaR--;
				print "\tM$misioL K$canibaL:\t---    <  MK|    ---\t:M$misioR K$canibaR\n";
				$misioL++; $canibaL++;
			}
		}
		$bank = ($bank + 1) % 2;
	}
}
		

my @stack;
# stav je popsan situaci na levem brehu, a to trojici <pocet misionaru>,<pocet kanibalu>,<pocet lodek>
# za strednikem se udrzuje historie pouzitych operandu. Jejich vyznam je nasledujici:
# 		1 - jeden misionar do lodky
# 		2 - dva misionari do lodky
# 		3 - jeden kanibal do lodky
# 		4 - dva kanibalove do lodky
# 		5 - jeden misionar a jeden kanibal do lodky
push @stack, '3,3,1;';
while (@stack) {
	my $state = shift @stack;
	$state =~ /(\d),(\d),(\d);(\d*)/;
	my $misioL = $1;
	my $canibaL = $2;
	my $boatL = $3;
	my $history = $4 || '';
	my $misioR = 3 - $misioL;
	my $canibaR = 3 - $canibaL;
	#print "Levy breh: m=$misioL    c=$canibaL\n";
	#print "Pravy breh: m=$misioR    c=$canibaR\n";
	if ($boatL) {
		#print "Lodka je na levem brehu\n";
		if (($misioL>0) and (($misioL==1) or (($misioL-1) >= $canibaL)) and (($misioR+1)>=$canibaR)) {
			my $nml = $misioL-1;
			push @stack, "$nml,$canibaL,0;${history}1";
			#print "Posilam jednoho misionare na pravy breh\n";
		}
		if (($misioL>1) and (($misioL==2) or (($misioL-2) >= $canibaL)) and (($misioR+2)>=$canibaR)) {
			my $nml = $misioL-2;
			push @stack, "$nml,$canibaL,0;${history}2";
			#print "Posilam dva misionare na pravy breh\n";
		}
		if (($canibaL>0) and (($misioR==0) or ($misioR >= ($canibaR+1)))) {
			my $ncl = $canibaL-1;
			push @stack, "$misioL,$ncl,0;${history}3";
			#print "Posilam jednoho kanibala na pravy breh\n";
		}
		if (($canibaL>1) and (($misioR==0) or ($misioR >= ($canibaR+2)))) {
			my $ncl = $canibaL-2;
			push @stack, "$misioL,$ncl,0;${history}4";
			#print "Posilam dva kanibaly na pravy breh\n";
		}
		if (($misioL > 0) and ($canibaL > 0) and (($misioR+1)>=($canibaR+1))) {
			my $nml = $misioL - 1;
			my $ncl = $canibaL - 1;
			push @stack, "$nml,$ncl,0;${history}5";
			#print "Posilam jednoho misionare a jednoho kanibala na pravy breh\n";
		}
	} else {
		#print "Lodka je na pravem brehu\n";
		if (($misioR==3) and ($canibaR == 3)) {
			print "Nalezeno reseni:\n";decode($history);
		} else {
			if (($misioR>0) and (($misioR==1) or (($misioR-1) >= $canibaR)) and (($misioL+1)>=$canibaL)) {
				my $nml = $misioL+1;
				push @stack, "$nml,$canibaL,1;${history}1";
				#print "Posilam jednoho misionare na levy breh\n";
			}
			if (($misioR>1) and (($misioR==2) or (($misioR-2) >= $canibaR)) and (($misioL+2)>=$canibaL)) {
				my $nml = $misioL+2;
				push @stack, "$nml,$canibaL,1;${history}2";
				#print "Posilam dva misionare na levy breh\n";
			}
			if (($canibaR>0) and (($misioL==0) or ($misioL >= ($canibaL+1)))) {
				my $ncl = $canibaL+1;
				push @stack, "$misioL,$ncl,1;${history}3";
				#print "Posilam jednoho kanibala na levy breh\n";
			}
			if (($canibaR>1) and (($misioL==0) or ($misioL >= ($canibaL+2)))) {
				my $ncl = $canibaL+2;
				push @stack, "$misioL,$ncl,1;${history}4";
				#print "Posilam dva kanibaly na levy breh\n";
			}
			if (($misioR > 0) and ($canibaR > 0) and (($misioL+1) >= ($canibaL+1))) {
				my $nml = $misioL + 1;
				my $ncl = $canibaL + 1;
				push @stack, "$nml,$ncl,1;${history}5";
				#print "Posilam jednoho misionare a jednoho kanibala na levy breh\n";
			}
		}
	}
}


